MODPROBE(8)

NAME
modprobe - program to add and remove modules from the Linux Kernel

SYNOPSIS
modprobe [ -v ] [ -V ] [ -C config-file ] [ -n ] [ -i ] [ -q ] [ -o modulename ] [ modulename ] [ module parameters ... ] modprobe [ -r ] [ -v ] [ -n ] [ -i ] [ modulename ... ] modprobe [ -l ] [ -t dirname ] [ wildcard ] modprobe [ -c ] modprobe [ --dump-modversions ]

DESCRIPTION

modprobe intelligently adds or removes a module from the Linux kernel: note that for convenience, there is no difference between _ and - in module names. modprobe looks in the module directory /lib/modules/`uname -r` for all the modules and other files, except for the optional /etc/modprobe.conf configuration file and /etc/modprobe.d directory (see modprobe.conf(5)).

Note that this version of modprobe does not do anything to the module itself: the work of resolving symbols and understanding parameters is done inside the kernel. So module failure is sometimes accompanied by a kernel message: see dmesg(8).

modprobe expects an up-to-date modules.dep file, as generated by depmod (see depmod(8)). This file lists what other modules each module needs (if any), and modprobe uses this to add or remove these dependencies automatically. See modules.dep(5)).

If any arguments are given after the modulename, they are passed to the kernel (in addition to any options listed in the configuration file).

OPTIONS

-v --verbose
    Print messages about what the program is doing. Usually modprobe only prints messages if something goes wrong. This option is passed through install or remove commands to other modprobe commands in the MODPROBE_OPTIONS environment variable.

-C --config
    This option overrides the default configuration file (/etc/modprobe.conf or /etc/modprobe.d/ if that isn't found). This option is passed through install or remove commands to other modprobe commands in the MODPROBE_OPTIONS environment variable.

-c --showconfig
    Dump out the configuration file and exit.

-n --dry-run
    This option does everything but actually insert or delete the modules (or run the install or remove commands). Combined with -v, it is useful for debugging problems.

-i --ignore-install --ignore-remove
    This option causes modprobe to ignore install and remove commands in the configuration file (if any), for the module on the command line (any dependent modules are still subject to commands set for them in the configuration file). See modprobe.conf(5).

-q --quiet
    Normally modprobe will report an error if you try to remove or insert a module it can't find (and isn't an alias or install/remove command). With this flag, modprobe will simply ignore any bogus names (the kernel uses this to opportunistically probe for modules which might exist).

-r --remove
    This option causes modprobe to remove, rather than insert a module. If the modules it depends on are also unused, modprobe will try to remove them, too. Unlike insertion, more than one module can be specified on the command line (it does not make sense to specify module parameters when removing modules). There is usually no reason to remove modules, but some buggy modules require it. Your kernel may not support removal of modules.

-w --wait
    This option is applicable only with the -r or --remove option. It causes modprobe to block in the kernel (within the kernel module handling code itself) waiting for the specified modules' reference count to reach zero. Default operation is for modprobe to operate like rmmod, which exits with EWOULDBLOCK if the modules reference count is non-zero.

-V --version
    Show version of program, and exit. See below for caveats when run on older kernels.

-f --force
    Try to strip any versioning information from the module, which might otherwise stop it from loading: this is the same as using both --force-vermagic and --force-modversion. Naturally, these checks are there for your protection, so using this option is dangerous. This applies to any modules inserted: both the module (or alias) on the command line, and any modules it depends on.

--force-vermagic
    Every module contains a small string containing important information, such as the kernel and compiler versions. If a module fails to load and the kernel complains that the "version magic" doesn't match, you can use this option to remove it. Naturally, this check is there for your protection, so this using option is dangerous. This applies to any modules inserted: both the module (or alias) on the command line, and any modules it depends on.

--force-modversion
    When modules are compiled with CONFIG_MODVERSIONS set, a section is created detailing the versions of every interface used by (or supplied by) the module. If a module fails to load and the kernel complains that the module disagrees about a version of some interface, you can use "--force-modversion" to remove the version information altogether. Naturally, this check is there for your protection, so using this option is dangerous. This applies any modules inserted: both the module (or alias) on the command line, and any modules it depends on.

-l --list
    List all modules matching the given wildcard (or "*" if no wildcard is given). This option is provided for backwards compatibility: see find(1) and basename(1) for a more flexible alternative.

-a --all
    Insert all module names on the command line.

-t --type
    Restrict -l to modules in directories matching the dirname given. This option is provided for backwards compatibility: see find(1) and basename(1) or a more flexible alternative.

-s --syslog
    This option causes any error messages to go through the syslog mechanism (as LOG_DAEMON with level LOG_NOTICE) rather than to standard error. This is also automatically enabled when stderr is unavailable. This option is passed through install or remove commands to other modprobe commands in the MODPROBE_OPTIONS environment variable.

--set-version
    Set the kernel version, rather than using uname(2) to decide on the kernel version (which dictates where to find the modules). This also disables backwards compatibility checks (so modprobe.old(8) will never be run).

--show-depends
    List the dependencies of a module (or alias), including the module itself. This produces a (possibly empty) set of module filenames, one per line, each starting with "insmod". Install commands which apply are shown prefixed by "install". It does not run any of the install commands. Note that modinfo(8) can be used to extract dependencies of a module from the module itself, but knows nothing of aliases or install commands.

-o --name
    This option tries to rename the module which is being inserted into the kernel. Some testing modules can usefully be inserted multiple times, but the kernel refuses to have two modules of the same name. Normally, modules should not require multiple insertions, as that would make them useless if there were no module support.

--first-time
    Normally, modprobe will succeed (and do nothing) if told to insert a module which is already present, or remove a module which isn't present. This is backwards compatible with the modutils, and ideal for simple scripts. However, more complicated scripts often want to know whether modprobe really did something: this option makes modprobe fail for that case.

--dump-modversions
    Print out a list of module versioning information required by a module. This option is commonly used by distributions in order to package up a Linuxx kernel module using module versioning deps.

BACKWARDS COMPATIBILITY

This version of modprobe is for kernels 2.5.48 and above. If it detects a kernel with support for old-style modules (for which much of the work was done in userspace), it will attempt to run modprobe.old in its place, so it is completely transparent to the user.

ENVIRONMENT

The MODPROBE_OPTIONS environment variable can also be used to pass arguments to modprobe.

COPYRIGHT

This manual page Copyright 2002, Rusty Russell, IBM Corporation.

SEE ALSO

modprobe.conf(5), lsmod(8), modprobe.old(8)